%define module_name	alsa
%define module_version	1.0.15
%define module_subver	%nil
%define module_release	alt1

%define module_full_version	%module_version%module_subver
%define module_source	ftp://ftp.alsa-project.org/pub/driver/alsa-driver-%module_full_version.tar.bz2
%define module_source_dir alsa-driver-%module_full_version

#### MODULE SOURCES ####
Name:          kernel-source-%module_name-%module_version
Version:       %module_version
Release:       %module_release
Summary:       Linux %module_name modules sources
License:       GPL
Group:         Development/Kernel
URL:           http://www.alsa-project.org/
BuildArch:     noarch
Provides:      kernel-source-%module_name = %module_full_version
Source0:       %module_source

Patch1: alsa-driver-1.0.10-intel8x0-blacklist.patch
Patch2: alsa-driver-1.0.9a-fm801-more-ids.patch
Patch4: alsa-driver-1.0.11rc1-alt-fix-compile.patch

#Patch29222: alsa-kernel-1.0.14-hg-9222-hda_codec-alc262-hp-xw.patch
#Patch29223: alsa-kernel-1.0.14-hg-9223-hda_codec-alc268-support.patch
#Patch29224: alsa-kernel-1.0.14-hg-9224-hda_codec-alc861-uniwill.patch
#Patch29225: alsa-kernel-1.0.14-hg-9225-hda_codec-alc883-msi.patch
#Patch29227: alsa-kernel-1.0.14-hg-9227-hda_codec-ad1984-thinkpad.patch
#Patch29228: alsa-kernel-1.0.14-hg-9228-hda_intel-nvidia.patch
#Patch29231: alsa-kernel-1.0.14-hg-9231-hda_codec-alc883-hp-a1589l.patch

Packager:       Kernel Maintainers Team <kernel@packages.altlinux.org>

#### KERNEL DOCUMENTATION ####
%package -n kernel-doc-%module_name-%module_version
Version:       %module_version
Summary:       Linux %module_name modules documentation
Group:         Development/Kernel

%description
%module_name modules sources for Linux kernel

%description -n kernel-doc-%module_name-%module_version
%module_name modules documentation for Linux kernel

#### KERNEL HEADERS ##########
%package -n kernel-headers-alsa
Summary: Header files for the %module_name modules system
Group: System/Kernel and hardware
Requires: kernel-headers
Obsoletes: alsa-driver-headers
Provides: alsa-driver-headers = %version-%release
Provides: kernel-headers-alsa-std-up = %version
Provides: kernel-headers-alsa-std-smp = %version

%description -n kernel-headers-alsa
The Advanced Linux Sound Architecture (ALSA) provides audio and MIDI
functionality to the Linux operating system. ALSA has the following
significant features:
1. Efficient support for all types of audio interfaces, from consumer
soundcards to professional multichannel audio interfaces.
2. Fully modularized sound drivers.
3. SMP and thread-safe design.
4. User space library (alsa-lib) to simplify application programming
and provide higher level functionality.
5. Support for the older OSS API, providing binary compatibility for
most OSS programs.

These are the C header files for the %module_name modules system,
which define structures and constants that are needed when building
most standard programs that use %module_name.



%prep
%setup -q -c

pushd %module_source_dir
%patch1 -p1
%patch2 -p1
%patch4 -p1

pushd alsa-kernel
#%patch29222 -p1
#%patch29223 -p1
#%patch29224 -p1
#%patch29225 -p1
#%patch29227 -p1
#%patch29228 -p1
#%patch29231 -p1
popd

find . -name '*.orig' -delete
popd

%__mkdir_p include
ln -sf ../%module_source_dir/alsa-kernel/include include/sound

%build
# Test compilation of headers in userspace
TestHeader()
{
	echo "#include <sound/$1>" > test.c
	gcc -c -I. $RPM_OPT_FLAGS test.c
}

# These headers have no equivalent in libalsa-devel
pushd include
TestHeader asequencer.h
TestHeader asound.h
TestHeader asound_fm.h
popd

%install
mkdir -p %buildroot%_usrsrc/kernel/sources
mkdir -p %buildroot%_includedir/sound
mkdir -p %buildroot%_defaultdocdir/%module_name-doc-%module_version
cp -a %module_source_dir/FAQ \
    %buildroot%_defaultdocdir/%module_name-doc-%module_version
cp -a %module_source_dir/doc/{SOUNDCARDS,*.txt} \
    %buildroot%_defaultdocdir/%module_name-doc-%module_version
cp -a %module_source_dir/alsa-kernel/Documentation/*.{txt,html} \
    %buildroot%_defaultdocdir/%module_name-doc-%module_version
mv %module_source_dir kernel-source-%module_name-%module_version
tar -c kernel-source-%module_name-%module_version | bzip2 -c > \
    %buildroot%_usrsrc/kernel/sources/kernel-source-%module_name-%module_version.tar.bz2
cp -r kernel-source-%module_name-%module_version/alsa-kernel/include/* %buildroot%_includedir/sound

%files
%_usrsrc/*

%files -n kernel-doc-%module_name-%module_version
%doc %_defaultdocdir/%module_name-doc-%module_version

%files -n kernel-headers-alsa
%_includedir/sound

%changelog
* Sun Oct 21 2007 Igor Zubkov <icesik@altlinux.org> 1.0.15-alt1
- NMU: 
  + 1.0.14 -> 1.0.15
- Remove obsoletes patches (fixed in upstream):
  + alsa-driver-1.0.14-hg-6150-core-kmemdup.patch
  + alsa-driver-1.0.14-hg-6151-asihpi-resource_size_t.patch
  + alsa-driver-1.0.14-hg-6152-usb_caiaq-api.patch
  + alsa-kernel-1.0.14-hg-9219-hda_codec-ad1984-oops.patch
  + alsa-kernel-1.0.14-hg-9220-doc-oss-duplex.patch
  + alsa-kernel-1.0.14-hg-9221-hda_codec-ad1984-basic.patch
  + alsa-kernel-1.0.14-hg-9222-hda_codec-alc262-hp-xw.patch
  + alsa-kernel-1.0.14-hg-9223-hda_codec-alc268-support.patch
  + alsa-kernel-1.0.14-hg-9224-hda_codec-alc861-uniwill.patch
  + alsa-kernel-1.0.14-hg-9225-hda_codec-alc883-msi.patch
  + alsa-kernel-1.0.14-hg-9227-hda_codec-ad1984-thinkpad.patch
  + alsa-kernel-1.0.14-hg-9228-hda_intel-nvidia.patch
  + alsa-kernel-1.0.14-hg-9231-hda_codec-alc883-hp-a1589l.patch

* Tue Jun 12 2007 Sergey Vlasov <vsu@altlinux.ru> 1.0.14-alt1
- 1.0.14.
- Removed all old hg-* patches (already in upstream).
- Dropped workqueue-flags patch (obsolete - was needed for some very old
  versions of the swsusp2 kernel patch).
- Dropped alt-hda_intel-disable-msi patch (obsolete - upstream version now
  defaults to not using MSI).
- Added patches from alsa-driver hg repo:
  + hg-6150: snd: fix kmemdup() wrapper usage
  + hg-6151: snd-asihpi: fix compatibility with 64-bit resource_size_t
  + hg-6152: snd-usb-caiaq: fix compatibility with kernels < 2.6.19
- Added patches from alsa-kernel hg repo:
  + hg-9220: Documentation: describe duplex streams with OSS emulation
  + hg-9219: snd-hda-codec: AD1984: fix oops with thinkpad model
  + hg-9221: snd-hda-codec: AD1984: fix basic model
  + hg-9222: snd-hda-codec: ALC262: support HP xw4550, xw4600, xw6600, xw8600
  + hg-9223: snd-hda-codec: add ALC268 codec support
  + hg-9224: snd-hda-codec: ALC861: add another Uniwill laptop support
  + hg-9225: snd-hda-codec: ALC883: add another MSI laptop (1462:0349)
  + hg-9227: snd-hda-codec: AD1984: fix Thinkpad X61/T61 outputs
  + hg-9231: snd-hda-codec: ALC883: add HP Pavillion a1589L
  + hg-9228: snd-hda-intel: add NVIDIA MCP73, MCP77 HD Audio support

* Sat Nov 11 2006 Sergey Vlasov <vsu@altlinux.ru> 1.0.13-alt1
- 1.0.13.
- Removed all old hg-* patches (already in upstream).
- Added patches from alsa-driver hg repo:
  + hg-6005: snd: fix build with disconnect oops fix (alsa-kernel hg-8718)
  + hg-5999: snd-usb-usx2y: fix for urb->start_frame changes in kernel 2.6.18
  + hg-6021: snd-usb-usx2y: fix the hg-5999 fix
- Added patches from alsa-kernel hg repo:
  + hg-8718: snd: fix disconnect oops due to wrong file operations handling
  + hg-8785: snd: fix re-use of va_list
  + hg-8787: snd: fix addition of user-defined boolean controls
  + hg-8794: snd-ac97-*: suppress power-saving mode on non-supporting drivers
  + hg-8709: snd-ac97-codec: ALC655: add EAPD hack for MSI L725 laptop
  + hg-8779: snd-ac97-codec: ALC655: enable speakers on MSI S250 laptop
  + hg-8786: snd-ac97-codec: fix AC97 power-saving mode
  + hg-8817: snd-ac97-codec: fix potential negative array index
  + hg-8743: snd-ad1816a: check kmalloc() return value
  + hg-8719: snd-au88x0: fix missing iounmap on module unload
  + hg-8742: snd-cmi8330: check kmalloc() return value
  + hg-8807: snd-echoaudio: fix potential NULL pointer dereference
  + hg-8706: snd-emu10k1: fix outl() in snd_emu10k1_resume_regs()
  + hg-8755: snd-hda-codec: fix wrong error checks for snd_hda_ch_mode_put()
  + hg-8756: snd-hda-codec: try to continue when modem codec init fails
  + hg-8758: snd-hda-codec: fix assignment of PCM devices for Realtek codecs
  + hg-8769: snd-hda-codec: ALC883: add support for Medion laptops
  + hg-8771: snd-hda-codec: AD1986A: add model entry for ASUS U5F laptop
  + hg-8772: snd-hda-codec: fix typo in hg-8769 fix
  + hg-8781: snd-hda-codec: ALC861: add support for Toshiba laptops
  + hg-8782: snd-hda-codec: add new models for Realtek codecs:
     + ALC262: add Hippo (ATI) and Hippo (Benq) models
     + ALC883: add Targa/MSI models (6ch and 2ch)
     + ALC660: add another ID for the codec chip
  + hg-8784: snd-hda-codec: fix typo in proc file
  + hg-8791: snd-hda-codec: ALC861: add support for ASUS laptops (A6Rp-AP002)
  + hg-8793: snd-hda-codec: ALC262: add model entry for HP q965
  + hg-8795: snd-hda-codec: AD1986A: add model entry for Lenovo A60 desktop
  + hg-8796: snd-hda-codec: STAC9205: add digital microphone support
  + hg-8806: snd-hda-codec: fix support for Dell systems with STAC9200 codecs
  + hg-8808: snd-hda-codec: ALC262: fix subsystem ID for HP xw4400
  + hg-8809: snd-hda-codec: AD1986A: add model entry for ASUS M2N-MX
  + hg-8811: snd-hda-codec: ALC883: add Clevo M540JE, M550JE laptop support
  + hg-8813: snd-hda-codec: AD1986A: add model entry for ASUS V1j laptop
  + hg-8815: snd-hda-codec: verbose proc output for PCM parameters
  + hg-8818: snd-hda-codec: fix typo in PCI ID for Samsung X11
  + hg-8814: snd-hda-codes: fix detection of supported sample rates
  + hg-8716: snd-hda-intel: increase maximum DMA buffer size to 1024 KB
  + hg-8777: snd-hda-intel: add ATI RS690 HDMI audio support
  + hg-8800: snd-hda-intel: add NVIDIA MCP61, MCP65, MCP67 HD Audio support
  + hg-8775: snd-hdsp: switch off precise_ptr control by default
  + hg-8741: snd-interwave: check kmalloc() return value
  + hg-8744: snd-opti92x-ad1848: check kmalloc() return value
  + hg-8797: snd-rtctimer: handle RTC interrupts with a tasklet
  + hg-8816: snd-usb-audio: fix hang-up at disconnection of usb-audio
  + hg-8701: snd-usb-usx2y: usX2Y_pcms_lock_check(): add NULL check
  + hg-8702: snd-usb-usx2y: fix for urb->start_frame changes in kernel 2.6.18
- Added patches:
  + alsa-driver-1.0.13-alt-hda_intel-disable-msi.patch: snd-hda-intel: disable
    Message Signaled Interrupt (MSI) by default

* Fri Sep 15 2006 Sergey Vlasov <vsu@altlinux.ru> 1.0.12-alt1
- 1.0.12.
- Removed obsolete patches:
  - alsa-kernel-1.0.11-hg-via-vt8251.patch
  - alsa-kernel-1.0.11-hg-pcxhr-64bit.patch
  - alsa-kernel-1.0.11-hg-hda-asus-m9.patch
  - alsa-kernel-1.0.11-hg-hda-ad1988b.patch
- Added patches from alsa-kernel hg repo:
  + hg-8610: snd-ac97-codec: enable S/PDIF on ASUS P5P800-VM
  + hg-8626: snd-ac97-codec: fix VIA EPIA (VT1617A codec) sound problem
  + hg-8638: snd-ac97-codec: fix AD1819 volume range
  + hg-8640: snd-ac97-codec: correct some Mic mixer element names
  + hg-8651: snd-ac97-codec: fix WM9705 AC97 patch build error
  + hg-8614: snd-ak4xxx-adda: fix volume control for the AK4358 DAC
  + hg-8639: snd-es1968: fix hardware volume control
  + hg-8609: snd-hda-codec: fix for Acer laptops with ALC883 codec
  + hg-8611: snd-hda-codec: support for SigmaTel STAC9872 (Vaio AR)
  + hg-8612: snd-hda-codec: restore HDA SigmaTel pin configs on resume
  + hg-8613: snd-hda-codec: fix mic capture with generic parser
  + hg-8620: snd-hda-codec: use model=ref for some Dell laptops
  + hg-8637: snd-hda-codec: add 5 stack audio support for Intel 965 systems
  + hg-8645: snd-hda-codec: enable center/LFE speaker on some laptops
  + hg-8646: snd-hda-codec: add independent headphone volume control
  + hg-8648: snd-hda-codec: add support for LG LW25 laptop
  + hg-8650: snd-hda-codec: fix SPDIF device number of ALC codecs
  + hg-8590: snd-hda-intel: switch to polling mode for CORB/RIRB communication
  + hg-8642: snd-hdsp: fix firmware autoloading
  + hg-8627: snd-usb-audio: support for non-standard rates in USB audio driver

* Sun Apr 23 2006 Sergey Vlasov <vsu@altlinux.ru> 1.0.11-alt1
- 1.0.11 final release.
- Added patches from ALSA Mercurial repository:
  + alsa-kernel-1.0.11-hg-via-vt8251.patch: via82xx: tweak VT8251 workaround
  + alsa-kernel-1.0.11-hg-pcxhr-64bit.patch: pcxhr: fix 64bit bug
  + alsa-kernel-1.0.11-hg-hda-asus-m9.patch: hda-codec: add model entry for
    ASUS M9 laptop
  + alsa-kernel-1.0.11-hg-hda-ad1988b.patch: hda-codec: add codec id for
    AD1988B codec chip

* Fri Mar 24 2006 Sergey Vlasov <vsu@altlinux.ru> 1.0.11-alt0.1.rc4
- 1.0.11rc4.

* Sun Mar 12 2006 Sergey Vlasov <vsu@altlinux.ru> 1.0.11-alt0.1.rc3
- 1.0.11rc3.
- Updated alt-fix-compile patch.
- Added:
  + alsa-driver-1.0.11rc1-workqueue-flags.patch: fix compilation with swsusp2
    patch which adds a second argument to create_workqueue()

* Sun Nov 20 2005 Sergey Vlasov <vsu@altlinux.ru> 1.0.10-alt1
- 1.0.10.
- Updated intel8x0-blacklist patch.

* Fri Jun 03 2005 Sergey Vlasov <vsu@altlinux.ru> 1.0.9a-alt1
- 1.0.9a.
- Removed obsolete patches from CVS.
- Added:
  + alsa-driver-1.0.9a-fm801-more-ids.patch: add another FM801 PCI ID

* Tue Jan 25 2005 Sergey Vlasov <vsu@altlinux.ru> 1.0.8-alt1
- 1.0.8.
- Removed obsolete vortex_adbdma_resetup and aureal-quadfix patches.
- Added patches from CVS:
  + 01_pcxhr-firmware-load.patch: fix pcxhr firmware loading bugs
  + 02_azx-realtek-pciid.patch: new PCI subsystem ID
  + 03_doc-typo.patch: fix typo in the list of values for the ac97_quirk option
  + 04_azx-capture-loopback.patch: fix capture and analog loopback in the
    generic codec parser
  + 05_vx-firmware-state.patch: show the firmware loading state in proc file
  + 06_intel8x0-ich7-pciid.patch: add ICH7 device ID to snd-intel8x0
  + 07_ac97-ad1981-jack-sense.patch: fixed the default state of "Headphone Jack
    Sense" switch on AD1981x codecs (turning it on unconditionally was breaking
    sound on several Thinkpad models)
  + 08_usbaudio-quirks.patch: don't use broken legacy interfaces on M-Audio
    Quattro/Omnistudio
  + 09_atiixp-modem-fix.patch: workaround for buggy ATI IXP chips
  + 10_missing-includes.patch: add missing #include <linux/device.h>
  + 11_ice1712-quirks.patch: add support for Chaintech 9CJS
  + 12_atiixp-quirks.patch: HP Pavilion ZV5030US mute LED support
  + 13_intel8x0-quirks.patch: HP nc8000 mute LED support
  + 14_ac97-jack-sense-quirks.patch: enable 'Headphone Jack Sense' control on
    FSC Scenic-W
  + 15_usbmidi-quirks.patch: add support for Yamaha UC-MX, UC-KX, CLP-175,
    SPX2000
  + 16_ac97-quirks.patch: fix sound output on the ASUS W1000 laptop with the
    CMI9739 chip (use EAPD instead of SPDIF in).

* Sun Oct 17 2004 Sergey Vlasov <vsu@altlinux.ru> 1.0.6a-alt2
- Restored changes from 1.0.4-alt2 which were lost in 1.0.6a-alt1:
  + Added Aureal patches from Manual Jander
  + Added Provides: kernel-source-%%module_name = %%module_version
- Replaced aureal-2.6.6.diff.gz with
  alsa-driver-1.0.6a-vortex_adbdma_resetup.patch (the only part which did not
  get merged to the main ALSA tree for some reason).
- Added alsa-driver-1.0.6a-alt-fix-compile.patch: fix header compilation with
  old kernel headers (glibc-kernheaders) without __user definition.
- Added header compilation check to %%build.

* Sat Oct 09 2004 Sergey Vlasov <vsu@altlinux.ru> 1.0.6a-alt1
- 1.0.6a
- Removed obsolete patches:
   - alsa-driver-1.0.4-via82xx-quirk.patch
   - alsa-driver-1.0.4-atiixp-spdif-fix.patch
   - alsa-driver-1.0.4-ac97-cache-spdif.patch
   - alsa-driver-1.0.4-ac97-powerdown.patch
   - alsa-driver-1.0.4-intel8x0-20bit.patch

* Thu Jun 10 2004 Alexey Morozov <morozov@altlinux.org> 1.0.4-alt2
- Added Aureal patches from Manual Jander:
  * http://galadriel.mat.utfsm.cl/~mjander/aureal/alsa/aureal-2.6.6.diff.gz
  * aureal-quadfix.patch (http://lists.gnu.org/archive/html/openvortex-dev/2004-06/txtLq3yTP8Vl0.txt)
- Added Provides: kernel-source-%%module_name = %%module_version

* Mon Apr 05 2004 Sergey Vlasov <vsu@altlinux.ru> 1.0.4-alt1
- 1.0.4
- Added patches from CVS:
  - alsa-driver-1.0.4-via82xx-quirk.patch: added dxs_support and ac97_quirk
    entries for Arima notebook
  - alsa-driver-1.0.4-atiixp-spdif-fix.patch: fixed SPDIF support (48k only)
  - alsa-driver-1.0.4-ac97-cache-spdif.patch: fixed the possible ac97 register
    cache mismatch; added the detection of spdif sample rates
  - alsa-driver-1.0.4-ac97-powerdown.patch: fix access to wrong register when
    clearing powerdown bits
  - alsa-driver-1.0.4-intel8x0-20bit.patch: 20-bit sample format support (for
    ICH4 and later devices)

* Tue Mar 02 2004 Sergey Vlasov <vsu@altlinux.ru> 1.0.3-alt1
- 1.0.3
- dropped ac97-quirk patch (upstream)

* Wed Feb 04 2004 Sergey Vlasov <vsu@altlinux.ru> 1.0.2c-alt1
- 1.0.2c

* Tue Feb 03 2004 Sergey Vlasov <vsu@altlinux.ru> 1.0.2b-alt1
- 1.0.2b
- spec file cleanup
- moved patches from kernel-modules-alsa-* here
- fixed file lists for kernel-doc-alsa

* Fri Jan 09 2004 Sergey Vlasov <vsu@altlinux.ru> 1.0.1-alt1
- 1.0.1
- added URL

* Wed Oct 22 2003 Sergey Vlasov <vsu@altlinux.ru> 0.9.8-alt1
- 0.9.8

* Mon Oct 13 2003 Sergey Vlasov <vsu@altlinux.ru> 0.9.7-alt1c
- 0.9.7c

* Sat Oct 11 2003 Sergey Vlasov <vsu@altlinux.ru> 0.9.7-alt1b
- 0.9.7b

* Wed Oct 08 2003 Rider <rider@altlinux.ru> 0.9.7-alt1a
- 0.9.7a 

* Fri Sep 26 2003 Sergey Vlasov <vsu@altlinux.ru> 0.9.7-alt1
- 0.9.7
- removed %%kversion-%%krelease from Provides: alsa-driver-headers

* Wed Jul 30 2003 Peter Novodvorsky <nidd@altlinux.com> 0.9.6-alt2
- added Obsoletes: alsa-drivers-headers to -headers.

* Wed Jul 30 2003 Peter Novodvorsky <nidd@altlinux.com> 0.9.6-alt1
- 0.9.6

* Tue Jul 29 2003 Peter Novodvorsky <nidd@altlinux.com> 0.9.5-alt2
- headers are generated from source package now.

* Tue Jul 15 2003 Michael Shigorin <mike@altlinux.ru> 0.9.5-alt1
- 0.9.5

* Thu Jun 12 2003 Peter Novodvorsky <nidd@altlinux.com> 0.9.4-alt1
- new upstream

* Fri Apr 18 2003 Peter Novodvorsky <nidd@altlinux.com> 0.9.2-alt2
- adopting to new kernel policy.

* Thu Mar 20 2003 Peter Novodvorsky <nidd@altlinux.com> 0.9.2-alt1
- new upstream

* Wed Feb 19 2003 Peter Novodvorsky <nidd@altlinux.org> 0.9.1-alt1
- initial release of NGKPs
